/*
Hugs!

Original Programming by Tatsuru
Modified by Fav so everyonehugs can actually. yknow. work with everyone lmfao
*/

/*
Futureproofing for v2.2.11 (Cause Uncapped do be spewing ye the 
"P_TeleportMove is deprecated" warning into your face) (Also thanks Lach)
*/
local P_MoveOrigin = P_MoveOrigin or P_TeleportMove
local P_SetOrigin = P_SetOrigin or P_TeleportMove

-- EveryoneHugs detection.
-- Just do your think normally if it's not added, but let it take control once it is.
local everyonehugs = false

addHook("ThinkFrame", do
	if AddHugger and not everyonehugs
		AddHugger("gemma")
		everyonehugs = true
	end
end)

addHook("NetVars", function(net)
	everyonehugs = net($)
end)

-- Heart object definition
freeslot("S_PLAY_GEMMAHUG", "SPR2_GHUG")

states[S_PLAY_GEMMAHUG] = {SPR_PLAY, SPR2_GHUG|FF_ANIMATE, 12, nil, 3, 4, S_PLAY_GEMMAHUG}

-- Love is in the air!
local function SpawnHearts(player)
	local heart = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.height, MT_CDLHRT)
	heart.destscale = (5*player.mo.scale)>>4
	heart.fuse = (5*TICRATE)>>1
	heart.momz = player.mo.scale
	heart.target = player.mo
	heart.extravalue1 = player.mo.x
	heart.extravalue2 = player.mo.y
end

-- Let's find the closest person to hug!
local function FindHugCandidates(rosy)
	local huggable
	
	for p in players.iterate
		-- Don't hug yourself
		if p == rosy continue end
		
		-- Hug only living players
		if not p.mo continue end
		if p.playerstate != PST_LIVE continue end
		
		-- No hugging in NiGHTS
		if p.powers[pw_carry] == CR_NIGHTSMODE continue end
		
		-- It's another Rosy and she's not hugging you
		if p.IwaflorGemma_hugging and rosy.IwaflorGemma_hugged != p continue end
		
		-- No hugging the enemy
		if p.ctfteam != rosy.ctfteam continue end
		
		-- Can't hug if not on the floor or doing anything
		if not(P_IsObjectOnGround(p.mo) and (p.panim == PA_IDLE or p.panim == PA_WALK or p.panim == PA_RUN))
			continue
		end
		
		-- Too high or too low to hug
		if abs(rosy.mo.z - p.mo.z) > 4*FRACUNIT continue end
		
		-- Too far away
		local dist = R_PointToDist2(rosy.mo.x, rosy.mo.y, p.mo.x, p.mo.y)
		if dist > rosy.mo.radius + p.mo.radius continue end
		
		-- Update the most likely candidate
		if not huggable or (huggable and dist < huggable.dist)
			huggable = p
			huggable.dist = dist
		end
	end
	
	return huggable
end

local function ReleaseHug(p)
	if p.IwaflorGemma_hugging -- We're hugging
		-- Do this to me
		p.pflags = $ & ~PF_STASIS
		if P_IsObjectOnGround(p.mo) then p.mo.state = S_PLAY_STND end
		p.IwaflorGemma_hugdelay = TICRATE
		p.FAV_Hugbacks = nil
		
		-- Do this to them
		if p.IwaflorGemma_hugging.valid
			p.IwaflorGemma_hugging.pflags = $ & ~PF_STASIS
			p.IwaflorGemma_hugging.IwaflorGemma_hugged = nil
			p.IwaflorGemma_hugging.hugged = nil
			p.Blake_GotHuggedLol = false -- Gemblake foreva?
		end
		
		p.IwaflorGemma_hugging = nil
		p.hugging = nil
	elseif p.IwaflorGemma_hugged -- We're being hugged
		-- Do this for me
		p.pflags = $ & ~PF_STASIS
		p.FAV_Hugbacks = nil
		
		-- Do this to them
		if p.IwaflorGemma_hugged.valid
			p.IwaflorGemma_hugged.pflags = $ & ~PF_STASIS
			--p.IwaflorGemma_hugged.mo.angle = R_PointToAngle2(p.mo.x, p.mo.y, p.IwaflorGemma_hugged.mo.x, p.IwaflorGemma_hugged.mo.y)
			p.IwaflorGemma_hugged.drawangle = p.IwaflorGemma_hugged.mo.angle
			p.IwaflorGemma_hugged.mo.state = S_PLAY_PAIN
			
			if p.IwaflorGemma_hugged.IwaflorGemma_hugtime > 1*TICRATE
				-- That's enough hugging
				p.IwaflorGemma_hugged.mo.sprite2 = SPR2_TRNS
				p.IwaflorGemma_hugged.mo.frame = G
				p.IwaflorGemma_hugged.thrown = true
			else
				-- Ouch!
				p.IwaflorGemma_hugged.mo.sprite2 = SPR2_PAIN
				S_StartSound(p.IwaflorGemma_hugged.mo, sfx_cdpcm7)
			end
			
			-- Fling Amy
			A_DoNPCPain(p.IwaflorGemma_hugged.mo)
			
			p.IwaflorGemma_hugged.IwaflorGemma_hugging = nil
			p.IwaflorGemma_hugged.hugging = nil
			p.IwaflorGemma_hugged.FAV_Hugbacks = nil
		end
		
		p.IwaflorGemma_hugged = nil
		p.hugged = nil
		p.IwaflorGemma_hugdelay = TICRATE
	end
end

-- Release!
local function UnhugEveryone()
	for p in players.iterate
		if p.IwaflorGemma_hug
			ReleaseHug(p)
		end
	end
end

addHook("PlayerThink", function(p)
	if not p.mo return end
	
	if p.mo.skin != "gemma"
		if p.IwaflorGemma_hug ReleaseHug(p) end
		
		return
	end
	
	//So other functions that rely on these variables can work!
	p.hugged = p.IwaflorGemma_hugged
	p.hugging = p.IwaflorGemma_hugging
	if not P_IsObjectOnGround(p.mo) then ReleaseHug(p) end
	
	local rosy = p
	
	-- Hug delay ticker
	rosy.IwaflorGemma_hugdelay = $ and $ - 1 or 0
	
	-- Curl when you're falling from being thrown
	if rosy.thrown and rosy.mo.momz < 0
		rosy.mo.sprite2 = SPR2_ROLL
		rosy.mo.frame = D
		rosy.thrown = false
	end
	
	-- Hug thinker ~
	if rosy.IwaflorGemma_hugging
		if not rosy.IwaflorGemma_hugging.valid
			ReleaseHug(rosy)
			return
		end
		
		// hey, you should be reacting to this too. bitch
		rosy.IwaflorGemma_hugging.hugged = rosy.IwaflorGemma_hugging.IwaflorGemma_hugged
		rosy.IwaflorGemma_hugging.hugging = rosy.IwaflorGemma_hugging.IwaflorGemma_hugging
		
		rosy.IwaflorGemma_hugging.pflags = $ | PF_STASIS	
		rosy.pflags = $ | PF_STASIS
		rosy.target = rosy.IwaflorGemma_hugging
		rosy.drawangle = rosy.IwaflorGemma_hugangle
		if rosy.mo.state ~= S_PLAY_GEMMAHUG
			rosy.mo.state = S_PLAY_GEMMAHUG
		end
		rosy.IwaflorGemma_hugtime = $ + 1
		
		if rosy.cmd.buttons & BT_CUSTOM1 and not rosy.IwaflorGemma_hugdelay
			ReleaseHug(rosy)
		elseif rosy.cmd.buttons & BT_CUSTOM3
			if not (leveltime & 7)
				SpawnHearts(rosy)
			end
		end
		
		return
	end
	
	local cand = FindHugCandidates(rosy)
	
	-- We don't have candidates? Get rid of the heart
	if not cand
		return
	end
	
	-- Hug!
	if rosy.cmd.buttons & BT_CUSTOM1 and not rosy.IwaflorGemma_hugdelay
	and not (rosy.pflags & PF_STASIS)
	and not (rosy.pflags & PF_FULLSTASIS)
	and rosy.mo.state != S_GEMMA_DANCE
	or rosy.FAV_Hugbacks -- hugbacks!!
		rosy.mo.momx = 0
		rosy.mo.momy = 0
		
		cand.IwaflorGemma_hugged = rosy
		rosy.IwaflorGemma_hugging = cand
		cand.FAV_Hugbacks = rosy
		cand.Blake_GotHuggedLol = true -- GEMBLAKE FOREVA!
		
		rosy.IwaflorGemma_hugtime = 0
		rosy.IwaflorGemma_hugangle = R_PointToAngle2(rosy.mo.x, rosy.mo.y, cand.mo.x, cand.mo.y)
		rosy.IwaflorGemma_hugdelay = TICRATE
		
		-- Ufufu~
		S_StartSound(rosy.mo, sfx_cdpcm6)
	end
end)


addHook("JumpSpecial", ReleaseHug)

// blake reaction gif
addHook("PlayerThink", do
	for player in players.iterate
		if player.mo and (player.mo.skin == "blake") 
			if (player.IwaflorGemma_hugged) and player.Blake_GotHuggedLol
				if player.mo.state != S_PLAY_STND or player.mo.sprite2 != SPR2_HUG_
					player.mo.state = S_PLAY_STND
					player.mo.sprite2 = SPR2_HUG_
					player.mo.tics = -1
				end
			end
		end
	end
end)